function Jpos=Jdisp(R,q,j)

% This function computes end-effector displacement

alpha=[pi/2 0 0 0];
d=[0 0 0 0];
a=[R(1,1) R(2,2) R(3,3) R(4,1)];

% Compute Homogeneous Transformation Matrices
Jpos=eye(4);
for i=1:j
   st=sin(q(i));
   ct=cos(q(i));
   sa=sin(alpha(i));
   ca=cos(alpha(i));
   A{i}=[ct -st*ca st*sa a(i)*ct;
      st ct*ca -ct*sa a(i)*st;
      0 sa ca d(i);
      0 0 0 1];
   Jpos=Jpos*A{i};
end
