function q=Rdisp(u,a)

% This function computes the reverse displacement analysis of the backhoe
xe=u(1);
ye=u(2);
ze=u(3);
phi=u(4);

p1o0o1=[a(1);0;0];
p4o3o4=[a(4);0;0];

% Solve for q(1) directly from endpoint position
q(1)=atan2(ye,xe);

% Rotation matrices
R01=Rx(pi/2)*Ry(q(1));
R04=Rx(pi/2)*Rz(pi)*Ry(-q(1))*Rz(phi);

% Solve position vectors for triangle 123
p0o0o4=[xe;ye;ze];
p0o3o4=R04*p4o3o4;
p1o3o4=R01'*p0o3o4;
p0o0o1=R01*p1o0o1;
p1o1o4=R01'*p0o0o4-p1o0o1;
p1o3o4=R01'*R04*p4o3o4;
p1o1o3=p1o1o4-p1o3o4;

% Use inverse trig and cosine law to get q(3)
PWx=p1o1o3(1);
PWy=p1o1o3(2);
T31x1=atan2(PWy,PWx);
R13=sqrt(PWx^2+PWy^2);
T321=acos((a(2)^2+a(3)^2-R13^2)/(2*a(2)*a(3)));
q(3)=pi+T321;

% Use cosine law to get q(2)
T213=acos((a(2)^2+R13^2-a(3)^2)/(2*a(2)*R13));
q(2)=T31x1+T213;

% Solve for q(4)
q(4)=phi-q(2)-q(3)+3*pi;