function [sys,x0,str,ts] = SFvel(t,x,u,flag,R)

% This function calls the Jacobian routine and then computes the 
% end-effector twist

% Switch based upon the current flag value
switch flag,
  case 0,
    [sys,x0,str,ts]=mdlInitializeSizes;
  case 3,
    sys=mdlOutputs(t,x,u,R);
  case {1,2,4,9}
    sys=[];
  otherwise
    error(['Unhandled flag = ',num2str(flag)]);
end

% end SFvel
%
%======================
% mdlInitializeSizes
%======================
%
function [sys,x0,str,ts]=mdlInitializeSizes

sizes = simsizes;

sizes.NumContStates  = 0;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 6;
sizes.NumInputs      = 8;
sizes.DirFeedthrough = 0;
sizes.NumSampleTimes = 1;   % at least one sample time is needed

sys = simsizes(sizes);
x0  = [];
str = [];
ts  = [0 0];

% end mdlInitializeSizes
%
%========================
% mdlOutputs
%========================
%
function sys=mdlOutputs(t,x,u,R)

q=u(1:4);
qd=u(5:8);

J=Jacobian(R,q);
yed=J*qd;


sys = yed;

% end mdlOutputs
