% This function plays a movie of the backhoe moving

% Extract vectors from simulation output matrix
t=tq(:,1);

% Desired joint angles
%qd1=qdes(:,1);
%qd2=qdes(:,2);
%qd3=qdes(:,3);
%qd4=qdes(:,4);

% Joystick joint angles (mapped from joystick position)
%qdp1=qdesp(:,1);
%qdp2=qdesp(:,2);
%qdp3=qdesp(:,3);
%qdp4=qdesp(:,4);

% Actual backhoe joint angles
q1=tq(:,2);
q2=tq(:,3);
q3=tq(:,4);
q4=tq(:,5);

% Plot individual joint trajectories
figure
k=0;
R=dimensions(1);
for i=1:length(t)

   % Generate Joint positions for the current configuration
   q=[q1(i);q2(i);q3(i);q4(i)];
   %qd=[qd1(i);qd2(i);qd3(i);qd4(i)];
   %qdp=[qdp1(i);qdp2(i);qdp3(i);qdp4(i)];
   
   % Create a set of link positions every few points
   if mod(i,100)==0 | i==1
      k=k+1;
      for j=1:4
         Jpos{j}=Jdisp(R,q,j);
         %Jposd{j}=Jdisp(R,qd,j);
         %Jposdp{j}=Jdisp(R,qdp,j);
      end
      
      % Backhoe joint positions
      J1x=Jpos{1}(1,4);
      J1y=Jpos{1}(2,4);
      J1z=Jpos{1}(3,4);
      J2x=Jpos{2}(1,4);
      J2y=Jpos{2}(2,4);
      J2z=Jpos{2}(3,4);
      J3x=Jpos{3}(1,4);
      J3y=Jpos{3}(2,4);
      J3z=Jpos{3}(3,4);
      J4x=Jpos{4}(1,4);
      J4y=Jpos{4}(2,4);
      J4z=Jpos{4}(3,4);
      Xpos=[J1x J2x J3x J4x]; 	% x0-positions of each joint at this time step
      Ypos=[J1y J2y J3y J4y]; 	% y0-positions of each joint at this time step
      Zpos=[J1z J2z J3z J4z];		% z0-positions of each joint at this time step
      
      % Operator's desired joint positions
      %J1xd=Jposd{1}(1,4);
      %J1yd=Jposd{1}(2,4);
      %J1zd=Jposd{1}(3,4);
      %J2xd=Jposd{2}(1,4);
      %J2yd=Jposd{2}(2,4);
      %J2zd=Jposd{2}(3,4);
      %J3xd=Jposd{3}(1,4);
      %J3yd=Jposd{3}(2,4);
      %J3zd=Jposd{3}(3,4);
      %J4xd=Jposd{4}(1,4);
      %J4yd=Jposd{4}(2,4);
      %J4zd=Jposd{4}(3,4);
      %Xposd=[J1xd J2xd J3xd J4xd]; 		% x0-positions of each joint at this time step
      %Yposd=[J1yd J2yd J3yd J4yd]; 		% y0-positions of each joint at this time step
      %Zposd=[J1zd J2zd J3zd J4zd];		% z0-positions of each joint at this time step
      
      % Joystick's joint positions, as mapped into backhoe's workspace
      %J1xdp=Jposdp{1}(1,4);
      %J1ydp=Jposdp{1}(2,4);
      %J1zdp=Jposdp{1}(3,4);
      %J2xdp=Jposdp{2}(1,4);
      %J2ydp=Jposdp{2}(2,4);
      %J2zdp=Jposdp{2}(3,4);
      %J3xdp=Jposdp{3}(1,4);
      %J3ydp=Jposdp{3}(2,4);
      %J3zdp=Jposdp{3}(3,4);
      %J4xdp=Jposdp{4}(1,4);
      %J4ydp=Jposdp{4}(2,4);
      %J4zdp=Jposdp{4}(3,4);
      %Xposdp=[J1xdp J2xdp J3xdp J4xdp]; 		% x0-positions of each joint at this time step
      %Yposdp=[J1ydp J2ydp J3ydp J4ydp]; 		% y0-positions of each joint at this time step
      %Zposdp=[J1zdp J2zdp J3zdp J4zdp];		% z0-positions of each joint at this time step     

      
      % Plot the joint trajectories:
      % lines along each link, then circles at joints
      %plot3(Xposd,Yposd,Zposd,'k')
      %mesh([-30 120],[-80 50],[-zg -zg])
      %plot3(Xposdp,Yposdp,Zposdp,'b')
      plot3(Xpos,Ypos,Zpos,'r')
      hold on
      legend('desired trajectory','joystick trajectory','bucket trajectory')
      %plot3(Xposd,Yposd,Zposd,'O')
      %plot3(Xposdp,Yposdp,Zposdp,'O')
      plot3(Xpos,Ypos,Zpos,'O')
      
      % put a circle at o0
      plot3(0,0,0,'O')
      grid on
      xlim([-30 120])
      ylim([-80 50])
      zlim([-80 50])
      title('Backhoe Joint Trajectories')
      xlabel('Extension position x_0 [in]')
      ylabel('Lateral position y_0 [in]')
      zlabel('Vertical position z_0 [in]')
      
      % draw a green surface at ground level
      %plot3([-10 100],[-zg -zg],'g')
      
      % Save as a movie frame
      view(-40,20)
      F(k)=getframe;
      hold off
   end
end
movie(F,10,8)